From 0b9bc14b9e0e0a9c37e3d7f4df010e845e4b3cdb Mon Sep 17 00:00:00 2001
From: janna <janna@cs.chalmer.se[D[D>
Date: Mon, 15 May 2006 09:04:34 +0000
Subject: [PATCH] russian

---
 lib/resource-1.0/russian/AdjectiveRus.gf   |   88 +-
 lib/resource-1.0/russian/AdverbRus.gf      |   48 +-
 lib/resource-1.0/russian/CatRus.gf         |  199 +-
 lib/resource-1.0/russian/ConjunctionRus.gf |  155 +-
 lib/resource-1.0/russian/IdiomRus.gf       |   52 +-
 lib/resource-1.0/russian/LangRus.gf        |   34 +-
 lib/resource-1.0/russian/LexiconRus.gf     |  760 ++++----
 lib/resource-1.0/russian/MorphoRus.gf      | 2003 ++++++++++++++++++--
 lib/resource-1.0/russian/NounRus.gf        |  243 ++-
 lib/resource-1.0/russian/NumeralRus.gf     |  149 +-
 lib/resource-1.0/russian/ParadigmsRus.gf   | 1393 +++++++++-----
 lib/resource-1.0/russian/PhraseRus.gf      |   42 +-
 lib/resource-1.0/russian/QuestionRus.gf    |  108 +-
 lib/resource-1.0/russian/RelativeRus.gf    |   82 +-
 lib/resource-1.0/russian/ResRus.gf         | 1103 +++++++----
 lib/resource-1.0/russian/SentenceRus.gf    |  130 +-
 lib/resource-1.0/russian/StructuralRus.gf  |  253 +--
 lib/resource-1.0/russian/VerbRus.gf        |  280 ++-
 18 files changed, 5010 insertions(+), 2112 deletions(-)

diff --git a/lib/resource-1.0/russian/AdjectiveRus.gf b/lib/resource-1.0/russian/AdjectiveRus.gf
index 07717b945..c544c8d87 100644
--- a/lib/resource-1.0/russian/AdjectiveRus.gf
+++ b/lib/resource-1.0/russian/AdjectiveRus.gf
@@ -1,42 +1,46 @@
-
---# -path=.:../abstract:../common:../../prelude
-
-
-concrete AdjectiveRus of Adjective = CatRus ** open ResRus, Prelude in {
---
---  lin
---
---    PositA  a = {
---      s = \\_ => a.s ! AAdj Posit ;
---      isPre = True
---      } ;
---    ComparA a np = {
---      s = \\_ => a.s ! AAdj Compar ++ "than" ++ np.s ! Nom ; 
---      isPre = False
---      } ;
---
----- $SuperlA$ belongs to determiner syntax in $Noun$.
---
---    ComplA2 a np = {
---      s = \\_ => a.s ! AAdj Posit ++ a.c2 ++ np.s ! Acc ; 
---      isPre = False
---      } ;
---
---    ReflA2 a = {
---      s = \\ag => a.s ! AAdj Posit ++ a.c2 ++ reflPron ! ag ; 
---      isPre = False
---      } ;
---
---    SentAP ap sc = {
---      s = \\a => ap.s ! a ++ sc.s ; 
---      isPre = False
---      } ;
---
---    AdAP ada ap = {
---      s = \\a => ada.s ++ ap.s ! a ;
---      isPre = ap.isPre
---      } ;
---
---    UseA2 a = a ;
---
-}
+
+--# -path=.:../abstract:../common:../../prelude
+
+
+concrete AdjectiveRus of Adjective = CatRus ** open ResRus, Prelude in {
+flags  coding=utf8 ;
+
+  lin
+
+    PositA  a = { s = a.s!Posit; p = False};
+       -- Comparative forms are used with an object of comparison, as
+        -- adjectival phrases ("больше тебя").
+
+    ComparA bolshoj tu =
+          {s = \\af => bolshoj.s ! Compar ! af ++ tu.s ! (mkPronForm Gen Yes NonPoss) ; 
+            p = True
+           } ;
+
+-- $SuperlA$ belongs to determiner syntax in $Noun$.
+
+    ComplA2 vlublen tu =
+    {s = \\af => vlublen.s !Posit! af ++ vlublen.s2 ++ 
+          tu.s ! (mkPronForm vlublen.c No NonPoss) ;
+     p = True
+    } ;
+
+    ReflA2 vlublen = 
+    {s = \\af => vlublen.s !Posit! af ++ vlublen.s2 ++ "себя";
+     p = True
+    } ;
+
+    SentAP vlublen sent= 
+    {s = \\af => vlublen.s ! af ++ sent.s;
+      p = True
+    } ;
+
+
+    AdAP ada ap = {
+      s = \\af => ada.s ++ ap.s ! af ;
+      p = True
+      } ;
+
+    UseA2 a = a ;
+
+}
+
diff --git a/lib/resource-1.0/russian/AdverbRus.gf b/lib/resource-1.0/russian/AdverbRus.gf
index f3cebe10e..8a5944813 100644
--- a/lib/resource-1.0/russian/AdverbRus.gf
+++ b/lib/resource-1.0/russian/AdverbRus.gf
@@ -1,23 +1,25 @@
---# -path=.:../abstract:../common:../../prelude
-
-concrete AdverbRus of Adverb = CatRus ** open ResRus, Prelude in {
---
---  lin
---    PositAdvAdj a = {s = a.s ! AAdv} ;
---    ComparAdvAdj cadv a np = {
---      s = cadv.s ++ a.s ! AAdv ++ "than" ++ np.s ! Nom
---      } ;
---    ComparAdvAdjS cadv a s = {
---      s = cadv.s ++ a.s ! AAdv ++ "than" ++ s.s
---      } ;
---
---    PrepNP prep np = {s = prep.s ++ np.s ! Acc} ;
---
---    AdAdv = cc2 ;
---
---    SubjS = cc2 ;
---    AdvSC s = s ; --- this rule give stack overflow in ordinary parsing
---
---    AdnCAdv cadv = {s = cadv.s ++ "than"} ;
---
-}
+--# -path=.:../abstract:../common:../../prelude
+
+concrete AdverbRus of Adverb = CatRus ** open ResRus, Prelude in {
+flags  coding=utf8 ;
+
+  lin
+    PositAdvAdj a = {s = a.s !Posit! AdvF} ;
+    ComparAdvAdj cadv a np = {
+      s = cadv.s ++ a.s !Posit! AdvF ++ "чем" ++ np.s ! PF Nom No NonPoss
+      } ;
+    ComparAdvAdjS cadv a s = {
+      s = cadv.s ++ a.s !Posit! AdvF ++ "чем" ++ s.s
+      } ;
+
+    PrepNP na stol = ss (na.s ++ stol.s ! PF na.c Yes NonPoss) ;
+
+    AdAdv = cc2 ;
+
+    SubjS = cc2 ;
+    AdvSC s = s ; --- this rule give stack overflow in ordinary parsing
+
+    AdnCAdv cadv = {s = cadv.s ++ "чем"} ;
+
+}
+
diff --git a/lib/resource-1.0/russian/CatRus.gf b/lib/resource-1.0/russian/CatRus.gf
index 6eeae4bd3..4c6b8bcbd 100644
--- a/lib/resource-1.0/russian/CatRus.gf
+++ b/lib/resource-1.0/russian/CatRus.gf
@@ -1,93 +1,106 @@
---# -path=.:../abstract:../common:../../prelude
-
-concrete CatRus of Cat = CommonX ** open ResRus, Prelude in {
---
---  flags optimize=all_subs ;
---
---  lincat
---
----- Phrase
---
---    Utt, Voc = {s : Str} ;
---
----- Tensed/Untensed
---
---    S  = {s : Str} ;
---    QS = {s : QForm => Str} ;
---    RS = {s : Agr => Str} ;
---
----- Sentence
---
---    Cl = {s : Tense => Anteriority => Polarity => Order => Str} ;
---    Slash = {s : Tense => Anteriority => Polarity => Order => Str} ** {c2 : Str} ;
---    Imp = {s : Polarity => Number => Str} ;
---
----- Question
---
---    QCl = {s : Tense => Anteriority => Polarity => QForm => Str} ;
---    IP = {s : Case => Str ; n : Number} ;
---    IAdv, IComp = {s : Str} ;    
---    IDet = {s : Str ; n : Number} ;
---
----- Relative
---
---    RCl = {s : Tense => Anteriority => Polarity => Agr => Str} ;
---    RP = {s : RCase => Str ; a : RAgr} ;
---
----- Verb
---
---    VP = {
---      s   : Tense => Anteriority => Polarity => Order => Agr => {fin, inf : Str} ;
---      prp : Str ; -- present participle
---      inf : Str ; -- infinitive
---      ad  : Str ;
---      s2  : Agr => Str
---      } ;
---    Comp = {s : Agr => Str} ; 
---    SC = {s : Str} ;
---
----- Adjective
---
---    AP = {s : Agr => Str ; isPre : Bool} ; 
---
----- Noun
---
---    CN = {s : Number => Case => Str} ;
---    NP, Pron = {s : Case => Str ; a : Agr} ;
---    Det = {s : Str ; n : Number} ;
---    Predet, QuantSg, QuantPl, Num, Ord = {s : Str} ;
---    Quant = {s : Number => Str} ;
---
----- Adverb
---
---    Adv, AdV, AdA, AdS, AdN = {s : Str} ;
---
----- Numeral
---
---    Numeral = {s : CardOrd => Str ; n : Number} ;
---
----- Structural
---
---    Conj = {s : Str ; n : Number} ;
---    DConj = {s1,s2 : Str ; n : Number} ;
---    PConj = {s : Str} ;    
---    CAdv = {s : Str} ;    
---    Subj = {s : Str} ;
---    Prep = {s : Str} ;
---
----- Open lexical classes, e.g. Lexicon
---
---    V, VS, VQ, VA = Verb ; -- = {s : VForm => Str} ;
---    V2, V2A = Verb ** {c2 : Str} ;
---    V3 = Verb ** {c2, c3 : Str} ;
---    VV = {s : VVForm => Str ; isAux : Bool} ;
---
---    A = {s : AForm => Str} ;
---    A2 = {s : AForm => Str ; c2 : Str} ;
---
---    N = {s : Number => Case => Str} ;
---    N2 = {s : Number => Case => Str} ** {c2 : Str} ;
---    N3 = {s : Number => Case => Str} ** {c2,c3 : Str} ;
---    PN = {s : Case => Str} ;
---
-}
+--# -path=.:../abstract:../common:../../prelude
+
+concrete CatRus of Cat = CommonX ** open ResRus, Prelude in {
+
+  flags optimize=all_subs ; coding=utf8 ;
+
+  lincat
+
+-- Phrase
+
+    Utt, Voc = {s : Str} ;
+
+-- Tensed/Untensed
+
+   S  = {s : Str} ;
+   SC  = {s : Str} ;
+   QS = {s :                 QForm => Str} ;
+   RS = {s :                   GenNum => Case => Animacy => Str} ;
+
+-- Sentence
+   -- clause (variable tense) e.g. "John walks"/"John walked"
+   Cl ={s : Polarity => ClForm => Str} ;
+   Slash = {s : Polarity => ClForm => Str; s2: Str; c: Case} ;
+   Imp = { s: Polarity => Gender => Number => Str } ;
+
+-- Question
+
+    QCl = {s :Polarity => ClForm => QForm => Str};  
+    IP = { s : PronForm => Str ; n : Number ; p : Person ;
+           g: PronGen ; anim : Animacy ;  pron: Bool} ;     
+    IAdv, IComp = {s : Str} ;    
+    IDet = Adjective ** {n: Number; g: PronGen; c: Case} ; 
+
+-- Relative
+
+    RCl = {s :  Polarity => ClForm => GenNum => Case => Animacy => Str} ;
+    RP = {s :                   GenNum => Case => Animacy => Str} ;
+
+-- Verb
+   -- Polarity =>
+   Comp, VP = {s : ClForm => GenNum => Person => Str ; asp : Aspect ; w: Voice} 
+          ** {s2 : Str ; s3 : Gender => Number => Str ; negBefore: Bool} ;
+
+
+-- Adjective
+    
+    AP = {s : AdjForm => Str; p : IsPostfixAdj} ; 
+
+-- Noun
+
+    CN = {s : Number => Case => Str; g : Gender; anim : Animacy} ;  
+    NP = { s : PronForm => Str ; n : Number ; p : Person ;
+           g: PronGen ; anim : Animacy ;  pron: Bool} ;     
+    Pron = { s : PronForm => Str ; n : Number ; p : Person ;
+           g: PronGen ;  pron: Bool} ;     
+
+-- Determiners (only determinative pronouns 
+-- (or even indefinite numerals: "много" (many)) in Russian) are inflected 
+-- according to the gender of nouns they determine.
+-- extra parameters (Number and Case) are added for the sake of                            	
+-- the determinative pronoun "bolshinstvo" ("most");
+-- Gender parameter is due to multiple determiners (Numerals in Russian)
+-- like "mnogo"
+-- The determined noun has the case parameter specific for the determiner
+    QuantSg, QuantPl , Det = {s : AdjForm => Str; n: Number; g: PronGen; c: Case} ; 
+    Predet, Quant= {s : AdjForm => Str; g: PronGen; c: Case} ; 
+
+-- Adverb
+
+    Adv, AdV, AdA, AdS, AdN = {s : Str} ;
+
+-- Numeral
+
+    Num, Numeral = {s : Case => Gender => Str} ;
+    
+-- Structural
+-- The conjunction has an inherent number, which is used when conjoining
+-- noun phrases: "Иван и Маша поют" vs. "Иван или Маша поет"; in the
+-- case of "или", the result is however plural if any of the disjuncts is.
+
+    Conj = {s : Str ; n : Number} ;  
+    DConj = {s1,s2 : Str ; n : Number} ; 
+    PConj = {s : Str} ;    
+    CAdv = {s : Str} ;    
+    Subj = {s : Str} ;
+    Prep = {s : Str ; c: Case } ;
+
+-- Open lexical classes, e.g. Lexicon
+
+    V, VS, VV, VQ, VA = Verbum ; -- = {s : VerbForm => Str ; asp : Aspect } ;
+    V2, V2A = Verbum ** Complement ; 
+    V3 = Verbum ** Complement** {s4 : Str; c2: Case} ; 
+--    VV = {s : VVForm => Str ; isAux : Bool} ;
+
+    Ord =  {s : AdjForm => Str} ;
+    A =  {s : Degree => AdjForm => Str} ;
+    A2 = A ** Complement ;
+
+ -- Substantives moreover have an inherent gender. 
+    N = {s : SubstForm => Str ; g : Gender ; anim : Animacy } ;   
+    N2 = {s : Number => Case => Str; g : Gender; anim : Animacy} ** Complement ;
+    N3 = {s : Number => Case => Str; g : Gender; anim : Animacy} ** Complement ** {s3 : Str; c2: Case} ;
+    PN = {s :  Case => Str ; g : Gender ; anim : Animacy} ;
+
+}
+
diff --git a/lib/resource-1.0/russian/ConjunctionRus.gf b/lib/resource-1.0/russian/ConjunctionRus.gf
index 3d8a3ee3e..4d8dc9d7b 100644
--- a/lib/resource-1.0/russian/ConjunctionRus.gf
+++ b/lib/resource-1.0/russian/ConjunctionRus.gf
@@ -1,47 +1,108 @@
---# -path=.:../abstract:../common:../../prelude
-
-concrete ConjunctionRus of Conjunction = 
-  CatRus ** open ResRus, Coordination, Prelude in {
---
---  flags optimize=all_subs ;
---
---  lin
---
---    ConjS = conjunctSS ;
---    DConjS = conjunctDistrSS ;
---
---    ConjAdv = conjunctSS ;
---    DConjAdv = conjunctDistrSS ;
---
---    ConjNP conj ss = conjunctTable Case conj ss ** {
---      a = {n = conjNumber conj.n ss.a.n ; p = ss.a.p}
---      } ;
---    DConjNP conj ss = conjunctDistrTable Case conj ss ** {
---      a = {n = conjNumber conj.n ss.a.n ; p = ss.a.p}
---      } ;
---
---    ConjAP conj ss = conjunctTable Agr conj ss ** {
---      isPre = ss.isPre
---      } ;
---    DConjAP conj ss = conjunctDistrTable Agr conj ss ** {
---      isPre = ss.isPre
---      } ;
---
----- These fun's are generated from the list cat's.
---
---    BaseS = twoSS ;
---    ConsS = consrSS comma ;
---    BaseAdv = twoSS ;
---    ConsAdv = consrSS comma ;
---    BaseNP x y = twoTable Case x y ** {a = conjAgr x.a y.a} ;
---    ConsNP xs x = consrTable Case comma xs x ** {a = conjAgr xs.a x.a} ;
---    BaseAP x y = twoTable Agr x y ** {isPre = andB x.isPre y.isPre} ;
---    ConsAP xs x = consrTable Agr comma xs x ** {isPre = andB xs.isPre x.isPre} ;
---
---  lincat
---    [S] = {s1,s2 : Str} ;
---    [Adv] = {s1,s2 : Str} ;
---    [NP] = {s1,s2 : Case => Str ; a : Agr} ;
---    [AP] = {s1,s2 : Agr => Str ; isPre : Bool} ;
---
-}
+--# -path=.:../abstract:../common:../../prelude
+
+concrete ConjunctionRus of Conjunction = 
+  CatRus ** open ResRus, Coordination, Prelude in {
+
+  flags optimize=all_subs ;  coding=utf8 ;
+
+  lin
+
+    ConjS = conjunctSS ;
+    DConjS = conjunctDistrSS ;
+
+    ConjAdv = conjunctSS ;
+    DConjAdv = conjunctDistrSS ;
+                                                    
+    ConjNP c xs =
+      conjunctTable PronForm c xs ** {n = conjNumber c.n xs.n ;
+      anim = xs.anim ;
+       p = xs.p; g = xs.g ; pron = xs.pron} ;
+
+
+    DConjNP  c xs =
+    conjunctDistrTable PronForm c xs ** {n = conjNumber c.n xs.n ; 
+      p = xs.p ; pron = xs.pron ; anim = xs.anim ; 
+       g = xs.g } ;
+
+
+    ConjAP c xs =    conjunctTable AdjForm c xs ** {p = xs.p} ;
+
+
+    DConjAP c xs = conjunctDistrTable AdjForm c xs ** {p = xs.p} ;
+
+-- These fun's are generated from the list cat's.
+
+    BaseS = twoSS ;
+    ConsS = consrSS comma ;
+    BaseAdv = twoSS ;
+    ConsAdv = consrSS comma ;
+
+
+    ConsNP  x xs =
+    consTable PronForm comma xs x ** 
+       {n = conjNumber xs.n x.n ; g = conjPGender x.g xs.g ;
+          anim = conjAnim x.anim xs.anim ;
+          p = conjPerson xs.p x.p; pron = conjPron xs.pron x.pron} ;
+      
+    ConsAP x xs = consTable AdjForm comma xs x ** {p = andB xs.p x.p} ;
+
+
+    BaseAP x y = twoTable AdjForm x y ** {p = andB x.p y.p} ;
+
+    BaseNP x y = twoTable PronForm x y ** {n = conjNumber x.n y.n ; 
+       g = conjPGender x.g y.g ; p = conjPerson x.p y.p ;
+       pron = conjPron x.pron y.pron ; anim = conjAnim x.anim y.anim } ;
+
+
+
+
+  lincat
+    [S] = {s1,s2 : Str} ;
+    [Adv] = {s1,s2 : Str} ;
+ -- The structure is the same as for sentences. The result is either always plural
+ -- or plural if any of the components is, depending on the conjunction.
+    [NP] = { s1,s2 : PronForm => Str ; g: PronGen ; 
+             anim : Animacy ; n : Number ; p : Person ;  pron : Bool } ;
+ -- The structure is the same as for sentences. The result is a prefix adjective
+ -- if and only if all elements are prefix.
+    [AP] =  {s1,s2 : AdjForm => Str ; p : Bool} ;
+
+
+
+oper
+  -- We have to define a calculus of numbers of persons. For numbers,
+-- it is like the conjunction with $Pl$ corresponding to $False$.
+
+  conjNumber : Number -> Number -> Number = \m,n -> case <m,n> of {
+    <Sg,Sg> => Sg ;
+    _ => Pl 
+    } ;
+
+-- For persons, we let the latter argument win ("либо ты, либо я пойду"
+-- but "либо я, либо ты пойдешь"). This is not quite clear.
+
+  conjPerson : Person -> Person -> Person = \_,p -> 
+    p ;
+
+-- For pron, we let the latter argument win - "Маша или моя мама" (Nominative case)
+-- but - "моей или Машина мама" (Genetive case) both corresponds to 
+-- "Masha's or my mother"), which is actually not exactly correct, since
+-- different cases should be used - "Машина или моя мама".
+
+  conjPron : Bool -> Bool -> Bool = \_,p -> 
+    p ;
+
+-- For gender in a similar manner as for person:
+-- Needed for adjective predicates like:
+-- "Маша или Оля - красивая", "Антон или Олег - красивый",
+-- "Маша или Олег - красивый".
+-- The later is not totally correct, but there is no correct way to say that.
+
+  conjGender : Gender -> Gender -> Gender = \_,m -> m ; 
+ conjPGender : PronGen -> PronGen -> PronGen = \_,m -> m ; 
+
+  conjAnim : Animacy -> Animacy -> Animacy = \_,m -> m ; 
+
+
+}
+
diff --git a/lib/resource-1.0/russian/IdiomRus.gf b/lib/resource-1.0/russian/IdiomRus.gf
index 9f683eb07..5ebc56691 100644
--- a/lib/resource-1.0/russian/IdiomRus.gf
+++ b/lib/resource-1.0/russian/IdiomRus.gf
@@ -1,15 +1,37 @@
---# -path=.:../abstract:../common:../../prelude
-
-concrete IdiomRus of Idiom = CatRus ** open Prelude, ResRus in {
---
---  flags optimize=all_subs ;
---
---  lin
---    ExistNP np = 
---      mkClause "there" (agrP3 np.a.n) (insertObj (\\_ => np.s ! Acc) (predAux auxBe)) ;
---    ImpersCl vp = mkClause "it" (agrP3 Sg) vp ;
---    GenericCl vp = mkClause "one" (agrP3 Sg) vp ;
---
---    ProgrVP vp = insertObj (\\a => vp.ad ++ vp.prp ++ vp.s2 ! a) (predAux auxBe) ;
---
-}
+--# -path=.:../abstract:../common:../../prelude
+
+concrete IdiomRus of Idiom = CatRus ** open Prelude, ResRus, MorphoRus in {
+
+  flags optimize=all_subs ;  coding=utf8 ;
+
+  lin
+    ExistNP = \bar ->
+    {s =\\b,clf => case b of 
+        {Pos =>  verbByut.s ! (getActVerbForm clf (pgen2gen bar.g) Sg P3) 
+           ++ bar.s ! PF Nom No NonPoss;
+        Neg => "не" ++ verbByut.s ! (getActVerbForm clf (pgen2gen bar.g) Sg P3) 
+           ++ bar.s ! PF Nom No NonPoss
+       }
+} ;
+
+
+    ImpersCl vp = {s= \\ b, clf =>  let ne= case b of {Pos =>[]; Neg =>""}
+      in 
+      ne ++ vp.s! clf! (ASg Neut) ! P3  }; 
+
+-- No direct correspondance in Russian. Usually expressed by infinitive:
+-- "Если очень захотеть, можно в космос улететь" 
+-- (If one really wants one can fly into the space).
+-- Note that the modal verb "can" is trasferred into adverb 
+-- "можно" (it is possible) in Russian
+-- The closest subject is "ты" (you), which is omitted in the final sentence:
+-- "Если очень захочешь, можешь в космос улететь"
+
+    GenericCl vp = {s= \\ b, clf =>  let ne= case b of {Pos =>[]; Neg =>""}
+      in 
+      ne ++ vp.s! clf! (ASg Masc) ! P3  }; 
+
+    ProgrVP vp = vp ;
+
+}
+
diff --git a/lib/resource-1.0/russian/LangRus.gf b/lib/resource-1.0/russian/LangRus.gf
index 058daf51f..a91740233 100644
--- a/lib/resource-1.0/russian/LangRus.gf
+++ b/lib/resource-1.0/russian/LangRus.gf
@@ -1,23 +1,17 @@
 --# -path=.:../abstract:../common:../../prelude
 
-
 concrete LangRus of Lang = 
---  NounRus, 
---  VerbRus, 
---  AdjectiveRus,
---  AdverbRus,
---  NumeralRus,
---  SentenceRus,
---  QuestionRus,
---  RelativeRus,
---  ConjunctionRus,
---  PhraseRus,
---  TextX,
---  StructuralRus,
---  IdiomRus,
---  LexiconRus
-  ** {
-
-flags startcat = Phr ; unlexer = text ; lexer = text ;
-
-} ;
+  NounRus, 
+  VerbRus, 
+  AdjectiveRus,
+  AdverbRus,
+  NumeralRus,
+  SentenceRus,
+  QuestionRus,
+  RelativeRus,
+  ConjunctionRus,
+  PhraseRus,
+  TextX,
+  StructuralRus,
+  IdiomRus,
+  LexiconRus ** { flags  startcat = Phr ; unlexer = text ; lexer = text ;} ;
diff --git a/lib/resource-1.0/russian/NumeralRus.gf b/lib/resource-1.0/russian/NumeralRus.gf
index 6a3840adb..1f7de26e3 100644
--- a/lib/resource-1.0/russian/NumeralRus.gf
+++ b/lib/resource-1.0/russian/NumeralRus.gf
@@ -1,46 +1,103 @@
---# -path=.:../abstract:../common:../../prelude
-
-concrete NumeralRus of Numeral = CatRus ** open ResRus in {
---
---lincat 
---  Digit = {s : DForm => CardOrd => Str} ;
---  Sub10 = {s : DForm => CardOrd => Str ; n : Number} ;
---  Sub100     = {s : CardOrd => Str ; n : Number} ;
---  Sub1000    = {s : CardOrd => Str ; n : Number} ;
---  Sub1000000 = {s : CardOrd => Str ; n : Number} ;
---
---lin num x = x ;
---lin n2 = let two = mkNum "two"   "twelve"   "twenty" "second" in
---         {s = \\f,c => case <f,c> of {
---             <teen,NOrd> => "twelfth" ;
---             _ => two.s ! f ! c
---             }
---         } ;
---
---lin n3 = mkNum "three" "thirteen" "thirty" "third" ;
---lin n4 = mkNum "four"  "fourteen" "forty" "fourth" ;
---lin n5 = mkNum "five"  "fifteen"  "fifty" "fifth" ;
---lin n6 = regNum "six" ;
---lin n7 = regNum "seven" ;
---lin n8 = mkNum "eight" "eighteen" "eighty" "eighth" ;
---lin n9 = regNum "nine" ;
---
---lin pot01 = mkNum "one" "eleven" "ten" "first" ** {n = Sg} ;
---lin pot0 d = d ** {n = Pl} ;
---lin pot110 = regCardOrd "ten" ** {n = Pl} ;
---lin pot111 = regCardOrd "eleven" ** {n = Pl} ;
---lin pot1to19 d = {s = d.s ! teen} ** {n = Pl} ;
---lin pot0as1 n = {s = n.s ! unit}  ** {n = n.n} ;
---lin pot1 d = {s = d.s ! ten} ** {n = Pl} ;
---lin pot1plus d e = {
---   s = \\c => d.s ! ten ! NCard ++ "-" ++ e.s ! unit ! c ; n = Pl} ;
---lin pot1as2 n = n ;
---lin pot2 d = {s = \\c => d.s ! unit ! NCard ++ mkCard c "hundred"}  ** {n = Pl} ;
---lin pot2plus d e = {
---  s = \\c => d.s ! unit ! NCard ++ "hundred" ++ "and" ++ e.s ! c ; n = Pl} ;
---lin pot2as3 n = n ;
---lin pot3 n = {
---  s = \\c => n.s ! NCard ++ mkCard c "thousand" ; n = Pl} ;
---lin pot3plus n m = {
---  s = \\c => n.s ! NCard ++ "thousand" ++ m.s ! c ; n = Pl} ;
-}
+--# -path=.:../abstract:../common:../../prelude
+
+concrete NumeralRus of Numeral = CatRus ** open ResRus in {
+
+flags  coding=utf8 ;
+
+-- Toiska, 13/8/2000, AR with Arto Mustajoki.
+
+lincat Digit = {s : DForm => Gender => Str ; size : Size} ;
+lincat Sub10 = {s : Place => DForm => Gender => Str ; size : Size} ;
+lincat Sub100 = {s : Place => Gender => Str ; size : Size} ;
+lincat Sub1000 = {s : Place => Gender => Str ; size : Size} ;
+lincat Sub1000000 = {s : Gender => Str} ;
+
+lin num x = {s = table{ _ => x.s }};
+
+lin n2  =
+  {s = table {{unit} => table {{Fem} => "две" ; _ => "два"} ; 
+            {teen} => gg "двенадцать" ; 
+            {ten}  => gg "двадцать" ;
+            {hund} => gg "двести"} ; 
+   size = sgg} ;
+lin n3  =
+  {s = table {{unit} => gg "три" ; 
+            {teen} => gg "тринадцать" ; 
+            {ten}  => gg "тридцать" ;
+            {hund} => gg "триста"} ; 
+  size = sgg} ;
+lin n4  =
+  {s = table {{unit} => gg "четыре" ; 
+            {teen} => gg "четырнадцать" ; 
+            {ten}  => gg "сорок" ;
+            {hund} => gg "четыреста"} ; 
+  size = sgg} ;
+lin n5  =
+  {s = table {{unit} => gg "пять" ; 
+            {teen} => gg "пятнадцать" ; 
+            {ten}  => gg "пятьдесят" ;
+            {hund} => gg "пятьсот"} ; 
+  size = plg} ;
+lin n6  =
+  {s = table {{unit} => gg "шесть" ; 
+            {teen} => gg "шестнадцать" ; 
+            {ten}  => gg "шестьдесят" ;
+            {hund} => gg "шестьсот"} ; 
+  size = plg} ;
+lin n7  =
+  {s = table {{unit} => gg "семь" ; 
+            {teen} => gg "семнадцать" ; 
+            {ten}  => gg "семьдесят" ;
+            {hund} => gg "семьсот"} ; 
+  size = plg} ;
+lin n8  =
+  {s = table {{unit} => gg "восемь" ; 
+            {teen} => gg "восемнадцать" ; 
+            {ten}  => gg "восемьдесят" ;
+            {hund} => gg "восемьсот"} ; 
+  size = plg} ;
+lin n9  =
+  {s = table {{unit} => gg "девять" ; 
+            {teen} => gg "девятнадцать" ; 
+            {ten}  => gg "девяносто" ;
+            {hund} => gg "девятьсот"} ; 
+  size = plg} ;
+
+
+lin pot01  =
+  {s = table {{attr} => table {{hund} => gg "сто" ; _ => gg []} ; 
+            _ => table {{hund} => gg "сто" ; 
+                     _ => table {{Masc} => "один" ; {Fem} => "одна" ; _ => "одно"}}} ;
+   size = nom} ;
+lin pot0 d =
+  {s = table {_ => d.s} ; size = d.size} ;
+lin pot110  =
+  {s = table {_ => gg "десять"} ; size = plg} ;
+lin pot111  =
+  {s = table {_ => gg "одиннадцать"} ; size = plg} ; --- 11
+lin pot1to19 d =
+  {s = table {_ => d.s ! teen} ; size = plg} ;
+lin pot0as1 n =
+  {s = table {p => n.s ! p ! unit} ; size = n.size} ;
+lin pot1 d =
+  {s = table {_ => d.s ! ten} ; size = plg} ; ---
+lin pot1plus d e =
+  {s = table {_ => 
+            table {g => d.s ! ten ! g ++ e.s ! indep ! unit ! g}} ; size = e.size} ;
+lin pot1as2 n =
+  {s = n.s ; size = n.size} ;
+lin pot2 d =
+  {s = table {p => d.s ! p ! hund} ; size = plg} ;
+lin pot2plus d e =
+  {s = table {p => table {g => d.s ! p ! hund ! g ++ e.s ! indep ! g}} ; size = e.size} ;
+lin pot2as3 n =
+  {s = n.s ! indep} ;
+lin pot3 n =
+  {s = gg (n.s ! attr ! Fem ++ mille ! n.size)} ;
+lin pot3plus n m =
+  {s = table {g => n.s ! attr ! Fem ++ mille ! n.size ++ m.s ! indep ! g}} ;
+
+--- TODO
+--- raz/odin
+}
+
